'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _reactRelayLibDliteFetchModeConstants = require('react-relay/lib/DliteFetchModeConstants');

var _reactRelayLibDliteFetchModeConstants2 = _interopRequireDefault(_reactRelayLibDliteFetchModeConstants);

var _reactRelayLibGraphQLQueryRunner = require('react-relay/lib/GraphQLQueryRunner');

var _reactRelayLibGraphQLQueryRunner2 = _interopRequireDefault(_reactRelayLibGraphQLQueryRunner);

var _reactRelayLibRelayPublic = require('react-relay/lib/RelayPublic');

var _reactRelayLibRelayPublic2 = _interopRequireDefault(_reactRelayLibRelayPublic);

var _reactRelayLibRelayPendingQueryTracker = require('react-relay/lib/RelayPendingQueryTracker');

var _reactRelayLibRelayPendingQueryTracker2 = _interopRequireDefault(_reactRelayLibRelayPendingQueryTracker);

exports['default'] = function (_ref, queryResults) {
    var Component = _ref.Component;
    var route = _ref.route;

    var querySet = _reactRelayLibRelayPublic2['default'].getQueries(Component, route);

    var request = new Promise(function (resolve, reject) {
        _reactRelayLibGraphQLQueryRunner2['default'].run(querySet, function (_ref2) {
            var aborted = _ref2.aborted;
            var done = _ref2.done;
            var error = _ref2.error;

            if (error) {
                reject(error);
            } else if (aborted) {
                reject(new Error('Aborted'));
            } else if (done) {
                resolve();
            }
        }, _reactRelayLibDliteFetchModeConstants2['default'].FETCH_MODE_PRELOAD);
    });
    Object.keys(querySet).forEach(function (name) {
        var result = queryResults[name];
        if (!result) {
            throw new Error('No result for query "' + name + '"');
        }
        _reactRelayLibRelayPendingQueryTracker2['default'].resolvePreloadQuery(querySet[name].getID(), { response: result });
    });
    return request;
};

module.exports = exports['default'];